local addon, ns = ...
local cfg = ns.cfg
local unpack = unpack
--------------------------------------------------------------
-- if not cfg.mastervolume.show then return end
local mastervolumeFrame = CreateFrame("BUTTON",nil, XIV_Databar) --cfg.SXframe
mastervolumeFrame:SetPoint("TOPLEFT",420,-1)
mastervolumeFrame:EnableMouse(true)
mastervolumeFrame:RegisterForClicks("AnyDown")

local mastervolumeIcon = mastervolumeFrame:CreateTexture(nil,"OVERLAY",nil,7)
mastervolumeIcon:SetPoint("LEFT")
mastervolumeIcon:SetTexture(cfg.mediaFolder.."datatexts\\sound")
--mastervolumeIcon:SetVertexColor(unpack(cfg.color.inactive))

local mastervolumeText = mastervolumeFrame:CreateFontString(nil, "OVERLAY")
mastervolumeText:SetFont(cfg.text.font, cfg.text.normalFontSize)
mastervolumeText:SetPoint("RIGHT", mastervolumeFrame,2,0)
mastervolumeText:SetTextColor(unpack(cfg.color.normal))

mastervolumeFrame:SetScript("OnEnter", function()
	if InCombatLockdown() then return end
	mastervolumeIcon:SetVertexColor(unpack(cfg.color.hover))
	
	--binding1UP, binding2UP = GetBindingKey("MASTERVOLUMEUP")
	--local binding1DOWN, binding2DOWN = GetBindingKey("MASTERVOLUMEDOWN")

	GameTooltip:SetOwner(mastervolumeFrame, "ANCHOR_BOTTOM")
	GameTooltip:AddLine("[|cff6699FFMaster Volume|r]")
	GameTooltip:AddLine(" ")
	--if binding1UP then
	--GameTooltip:AddDoubleLine("< |cff6699FF" ..binding1UP.. "|r  >", "|cffffffffMaster Volume UP|r")
	--else
	--GameTooltip:AddLine("|cffffffffYou have no keybind to Master volume UP|r")
	--end
	--if binding1DOWN then
	--GameTooltip:AddDoubleLine("< |cff6699FF" ..binding1DOWN.. "|r  >", "|cffffffffMaster Volume DOWN|r")
	--else
	--GameTooltip:AddLine("|cffffffffYou have no keybind to Master volume DOWN|r")
	--end
	GameTooltip:AddDoubleLine("<Left-click>", "|cffffffffMaster Volume UP|r")
	GameTooltip:AddDoubleLine("<Right-click>", "|cffffffffMaster Volume DOWN|r")
	GameTooltip:Show()
end)
mastervolumeFrame:SetScript("OnClick", function(self, button, down)
	local volume = tonumber(GetCVar("Sound_MasterVolume"));
	
	if button == "LeftButton" then
	
	SetCVar( "Sound_MasterVolume", volume + 0.1);

	elseif button == "RightButton" then
	SetCVar( "Sound_MasterVolume", volume - 0.1);
	end
	volume = tonumber(GetCVar("Sound_MasterVolume"));
	if volume <=0 then SetCVar( "Sound_MasterVolume", 0); end
	if volume >=1 then SetCVar( "Sound_MasterVolume", 1); end
end)



mastervolumeFrame:SetScript("OnLeave", function()

	mastervolumeIcon:SetVertexColor(unpack(cfg.color.normal)) 
	GameTooltip:Hide();
end)

local eventframe = CreateFrame("Frame")
eventframe:RegisterEvent("PLAYER_ENTERING_WORLD");
eventframe:RegisterEvent("CVAR_UPDATE");

eventframe:SetScript("OnEvent", function(self,event, ...)
	MasterVolume_Update_Value();
end)

function MasterVolume_Update_Value()
	local volume = tonumber(GetCVar("Sound_MasterVolume"));
	local volumePercent = (volume * 100);
	local volumePercentTrimed = tonumber(string.format("%.1f", volumePercent));
	mastervolumeText:SetText(volumePercentTrimed.." %")

	mastervolumeFrame:SetSize(mastervolumeText:GetStringWidth()+18, 16)
end

hooksecurefunc("Sound_MasterVolumeUp", MasterVolume_Update_Value)
hooksecurefunc("Sound_MasterVolumeDown", MasterVolume_Update_Value)

hooksecurefunc("SetCVar", function(cvar, value)
	if cvar == "Sound_MasterVolume" then
		MasterVolume_Update_Value()
	end
end)